Index: /palm/trunk/SOURCE/basic_constants_and_equations_mod.f90
===================================================================
--- /palm/trunk/SOURCE/basic_constants_and_equations_mod.f90	(revision 3274)
+++ /palm/trunk/SOURCE/basic_constants_and_equations_mod.f90	(revision 3274)
@@ -0,0 +1,357 @@
+!> @file basic_constants_and_equations_mod.f90
+!------------------------------------------------------------------------------!
+! This file is part of the PALM model system.
+!
+! PALM is free software: you can redistribute it and/or modify it under the
+! terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later
+! version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
+! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
+! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 1997-2018 Leibniz Universitaet Hannover
+!------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+! New module (introduced with modularization of bulk cloud physics model)
+!
+! 
+!
+!
+! Description:
+! ------------
+!> This module contains all basic (physical) constants
+!> and
+!> functions for the calculation of diagnostic quantities.
+!------------------------------------------------------------------------------!
+ MODULE basic_constants_and_equations_mod
+
+
+    USE kinds
+
+    IMPLICIT NONE
+
+    REAL(wp), PARAMETER ::  pi = 3.141592654_wp  !< PI
+
+    REAL(wp), PARAMETER ::  c_p = 1005.0_wp                           !< heat capacity of dry air (J kg-1 K-1)
+    REAL(wp), PARAMETER ::  g = 9.81_wp                               !< gravitational acceleration (m s-2)
+    REAL(wp), PARAMETER ::  kappa = 0.4_wp                            !< von Karman constant
+    REAL(wp), PARAMETER ::  l_m = 0.33E+06_wp                         !< latent heat of water melting (J kg-1)
+    REAL(wp), PARAMETER ::  l_v = 2.5E+06_wp                          !< latent heat of water vaporization (J kg-1)
+    REAL(wp), PARAMETER ::  l_s = l_m + l_v                           !< latent heat of water sublimation (J kg-1)
+    REAL(wp), PARAMETER ::  molecular_weight_of_nacl = 0.05844_wp     !< mol. m. NaCl (kg mol-1)
+    REAL(wp), PARAMETER ::  molecular_weight_of_c3h4o4 = 0.10406_wp   !< mol. m. malonic acid (kg mol-1)
+    REAL(wp), PARAMETER ::  molecular_weight_of_nh4no3 = 0.08004_wp   !< mol. m. ammonium sulfate (kg mol-1)
+    REAL(wp), PARAMETER ::  molecular_weight_of_water = 0.01801528_wp !< mol. m. H2O (kg mol-1)
+    REAL(wp), PARAMETER ::  rho_l = 1.0E3_wp                          !< density of water (kg m-3)
+    REAL(wp), PARAMETER ::  rho_nacl = 2165.0_wp                      !< density of NaCl (kg m-3)
+    REAL(wp), PARAMETER ::  rho_c3h4o4 = 1600.0_wp                    !< density of malonic acid (kg m-3)
+    REAL(wp), PARAMETER ::  rho_nh4no3 = 1720.0_wp                    !< density of ammonium sulfate (kg m-3)
+    REAL(wp), PARAMETER ::  r_d = 287.0_wp                            !< sp. gas const. dry air (J kg-1 K-1)
+    REAL(wp), PARAMETER ::  r_v = 461.51_wp                           !< sp. gas const. water vapor (J kg-1 K-1)
+    REAL(wp), PARAMETER ::  sigma_sb = 5.67E-08_wp                    !< Stefan-Boltzmann constant
+    REAL(wp), PARAMETER ::  solar_constant = 1368.0_wp                !< solar constant at top of atmosphere
+    REAL(wp), PARAMETER ::  vanthoff_nacl = 2.0_wp                    !< van't Hoff factor for NaCl
+    REAL(wp), PARAMETER ::  vanthoff_c3h4o4 = 1.37_wp                 !< van't Hoff factor for malonic acid
+    REAL(wp), PARAMETER ::  vanthoff_nh4no3 = 2.31_wp                 !< van't Hoff factor for ammonium sulfate
+
+    REAL(wp), PARAMETER ::  p_0 = 100000.0_wp                         !< standard pressure reference state
+
+    REAL(wp), PARAMETER ::  g_d_cp  = g   / c_p   !< precomputed g / c_p
+    REAL(wp), PARAMETER ::  lv_d_cp = l_v / c_p   !< precomputed l_v / c_p
+    REAL(wp), PARAMETER ::  lv_d_rd = l_v / r_d   !< precomputed l_v / r_d
+    REAL(wp), PARAMETER ::  rd_d_cp = 0.286_wp !r_d / c_p  !< precomputed r_d / c_p
+    REAL(wp), PARAMETER ::  cp_d_rd = 1.0_wp/0.286_wp !c_p / r_d  !< precomputed c_p / r_d
+
+    REAL(wp) ::  molecular_weight_of_solute = molecular_weight_of_nacl  !< mol. m. NaCl (kg mol-1)
+    REAL(wp) ::  rho_s = rho_nacl                                       !< density of NaCl (kg m-3)
+    REAL(wp) ::  vanthoff = vanthoff_nacl                               !< van't Hoff factor for NaCl
+
+
+    SAVE
+
+    PRIVATE magnus_0d, &
+            magnus_1d, &
+            ideal_gas_law_rho_0d, &
+            ideal_gas_law_rho_1d, &
+            ideal_gas_law_rho_pt_0d, &
+            ideal_gas_law_rho_pt_1d, &
+            exner_function_0d, &
+            exner_function_1d, &
+            exner_function_invers_0d, &
+            exner_function_invers_1d, &
+            barometric_formula_0d, &
+            barometric_formula_1d
+
+    INTERFACE magnus
+       MODULE PROCEDURE magnus_0d
+       MODULE PROCEDURE magnus_1d
+    END INTERFACE magnus
+
+    INTERFACE ideal_gas_law_rho
+       MODULE PROCEDURE ideal_gas_law_rho_0d
+       MODULE PROCEDURE ideal_gas_law_rho_1d
+    END INTERFACE ideal_gas_law_rho
+
+    INTERFACE ideal_gas_law_rho_pt
+       MODULE PROCEDURE ideal_gas_law_rho_pt_0d
+       MODULE PROCEDURE ideal_gas_law_rho_pt_1d
+    END INTERFACE ideal_gas_law_rho_pt
+
+    INTERFACE exner_function
+       MODULE PROCEDURE exner_function_0d
+       MODULE PROCEDURE exner_function_1d
+    END INTERFACE exner_function
+
+    INTERFACE exner_function_invers
+       MODULE PROCEDURE exner_function_invers_0d
+       MODULE PROCEDURE exner_function_invers_1d
+    END INTERFACE exner_function_invers
+
+    INTERFACE barometric_formula
+       MODULE PROCEDURE barometric_formula_0d
+       MODULE PROCEDURE barometric_formula_1d
+    END INTERFACE barometric_formula
+
+ CONTAINS
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> This function computes the magnus formula (Press et al., 1992).
+!> The magnus formula is needed to calculate the saturation vapor pressure
+!------------------------------------------------------------------------------!
+    FUNCTION magnus_0d( t )
+
+       IMPLICIT NONE
+
+       REAL(wp), INTENT(IN) ::  t  !< temperature (K)
+
+       REAL(wp) ::  magnus_0d
+!
+!--    Saturation vapor pressure for a specific temperature:
+       magnus_0d =  611.2_wp * EXP( 17.62_wp * ( t - 273.15_wp ) /             &
+                                                   ( t - 29.65_wp  ) )
+
+    END FUNCTION magnus_0d
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> This function computes the magnus formula (Press et al., 1992).
+!> The magnus formula is needed to calculate the saturation vapor pressure
+!------------------------------------------------------------------------------!
+    FUNCTION magnus_1d( t )
+
+       IMPLICIT NONE
+
+       REAL(wp), INTENT(IN), DIMENSION(:) ::  t  !< temperature (K)
+
+       REAL(wp), DIMENSION(size(t)) ::  magnus_1d
+!
+!--    Saturation vapor pressure for a specific temperature:
+       magnus_1d =  611.2_wp * EXP( 17.62_wp * ( t - 273.15_wp ) /             &
+                                               ( t - 29.65_wp  ) )
+
+    END FUNCTION magnus_1d
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Compute the ideal gas law for scalar arguments.
+!------------------------------------------------------------------------------!
+    FUNCTION ideal_gas_law_rho_0d( p, t )
+
+       IMPLICIT NONE
+
+       REAL(wp), INTENT(IN) ::  p  !< pressure (Pa)
+       REAL(wp), INTENT(IN) ::  t  !< temperature (K)
+
+       REAL(wp) ::  ideal_gas_law_rho_0d
+!
+!--    compute density according to ideal gas law:
+       ideal_gas_law_rho_0d = p / (r_d * t)
+
+    END FUNCTION ideal_gas_law_rho_0d
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Compute the ideal gas law for 1-D array arguments.
+!------------------------------------------------------------------------------!
+    FUNCTION ideal_gas_law_rho_1d( p, t )
+
+       IMPLICIT NONE
+
+       REAL(wp), INTENT(IN), DIMENSION(:) ::  p  !< pressure (Pa)
+       REAL(wp), INTENT(IN), DIMENSION(:) ::  t  !< temperature (K)
+
+       REAL(wp), DIMENSION(size(p)) ::  ideal_gas_law_rho_1d
+!
+!--    compute density according to ideal gas law:
+       ideal_gas_law_rho_1d = p / (r_d * t)
+
+    END FUNCTION ideal_gas_law_rho_1d
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Compute the ideal gas law for scalar arguments.
+!------------------------------------------------------------------------------!
+    FUNCTION ideal_gas_law_rho_pt_0d( p, t )
+
+       IMPLICIT NONE
+
+       REAL(wp), INTENT(IN) ::  p  !< pressure (Pa)
+       REAL(wp), INTENT(IN) ::  t  !< temperature (K)
+
+       REAL(wp) ::  ideal_gas_law_rho_pt_0d
+!
+!--    compute density according to ideal gas law:
+       ideal_gas_law_rho_pt_0d = p / (r_d * (1.0_wp / exner_function_invers(p)) * t)
+
+    END FUNCTION ideal_gas_law_rho_pt_0d
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Compute the ideal gas law for 1-D array arguments.
+!------------------------------------------------------------------------------!
+    FUNCTION ideal_gas_law_rho_pt_1d( p, t )
+
+       IMPLICIT NONE
+
+       REAL(wp), INTENT(IN), DIMENSION(:) ::  p  !< pressure (Pa)
+       REAL(wp), INTENT(IN), DIMENSION(:) ::  t  !< temperature (K)
+
+       REAL(wp), DIMENSION(size(p)) ::  ideal_gas_law_rho_pt_1d
+!
+!--    compute density according to ideal gas law:
+       ideal_gas_law_rho_pt_1d = p / (r_d * (1.0_wp / exner_function_invers(p)) * t)
+
+    END FUNCTION ideal_gas_law_rho_pt_1d
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Compute the exner function for scalar arguments.
+!------------------------------------------------------------------------------!
+    FUNCTION exner_function_0d( p )
+
+       IMPLICIT NONE
+
+       REAL(wp), INTENT(IN) ::  p    !< pressure (Pa)
+
+       REAL(wp) ::  exner_function_0d
+!
+!--    compute exner function:
+       exner_function_0d = ( p / p_0 )**( rd_d_cp )
+
+    END FUNCTION exner_function_0d
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Compute the exner function for 1-D array arguments.
+!------------------------------------------------------------------------------!
+    FUNCTION exner_function_1d( p )
+
+       IMPLICIT NONE
+
+       REAL(wp), INTENT(IN), DIMENSION(:) ::  p  !< pressure (Pa)
+
+       REAL(wp), DIMENSION(size(p)) ::  exner_function_1d
+!
+!--    compute exner function:
+       exner_function_1d = ( p / p_0 )**( rd_d_cp )
+
+    END FUNCTION exner_function_1d
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Compute the exner function for scalar arguments.
+!------------------------------------------------------------------------------!
+    FUNCTION exner_function_invers_0d( p )
+
+       IMPLICIT NONE
+
+       REAL(wp), INTENT(IN) ::  p    !< pressure (Pa)
+
+       REAL(wp) ::  exner_function_invers_0d
+!
+!--    compute exner function:
+       exner_function_invers_0d = ( p_0 / p )**( rd_d_cp )
+
+    END FUNCTION exner_function_invers_0d
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Compute the exner function for 1-D array arguments.
+!------------------------------------------------------------------------------!
+    FUNCTION exner_function_invers_1d( p )
+
+       IMPLICIT NONE
+
+       REAL(wp), INTENT(IN), DIMENSION(:) ::  p  !< pressure (Pa)
+
+       REAL(wp), DIMENSION(size(p)) ::  exner_function_invers_1d
+!
+!--    compute exner function:
+       exner_function_invers_1d = ( p_0 / p )**( rd_d_cp )
+
+    END FUNCTION exner_function_invers_1d
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Compute the barometric formula for scalar arguments.
+!------------------------------------------------------------------------------!
+    FUNCTION barometric_formula_0d( z, t_0, p_0)
+
+       IMPLICIT NONE
+
+       REAL(wp), INTENT(IN) ::  z    !< height (m)
+       REAL(wp), INTENT(IN) ::  t_0  !< temperature reference state (K)
+       REAL(wp), INTENT(IN) ::  p_0  !< surface pressure (Pa)
+
+       REAL(wp) ::  barometric_formula_0d
+!
+!--    compute barometric formula:
+       barometric_formula_0d =  p_0 * ( (t_0 - g_d_cp * z) / t_0 )**( cp_d_rd )
+
+    END FUNCTION barometric_formula_0d
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Compute the barometric formula for 1-D array arguments.
+!------------------------------------------------------------------------------!
+    FUNCTION barometric_formula_1d( z, t_0, p_0)
+
+       IMPLICIT NONE
+
+       REAL(wp), INTENT(IN), DIMENSION(:) ::  z  !< height (m)
+       REAL(wp), INTENT(IN) ::  t_0              !< temperature reference state (K)
+       REAL(wp), INTENT(IN) ::  p_0              !< surface pressure (Pa)
+
+       REAL(wp), DIMENSION(size(z)) ::  barometric_formula_1d
+!
+!--    compute barometric formula:
+       barometric_formula_1d =  p_0 * ( (t_0 - g_d_cp * z) / t_0 )**( cp_d_rd )
+
+    END FUNCTION barometric_formula_1d
+
+ END MODULE basic_constants_and_equations_mod
Index: /palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- /palm/trunk/SOURCE/boundary_conds.f90	(revision 3273)
+++ /palm/trunk/SOURCE/boundary_conds.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -197,4 +200,7 @@
                w, w_p, w_m_l, w_m_n, w_m_r, w_m_s
 
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  kappa
+
     USE chemistry_model_mod,                                                   &
         ONLY:  chem_boundary_conds 
@@ -204,9 +210,8 @@
                bc_dirichlet_s, bc_radiation_l, bc_radiation_n, bc_radiation_r, &
                bc_radiation_s, bc_pt_t_val, bc_q_t_val, bc_s_t_val,            &
-               child_domain, constant_diffusion, cloud_physics, coupling_mode, &
+               child_domain, constant_diffusion, coupling_mode, &
                dt_3d, humidity, ibc_pt_b, ibc_pt_t, ibc_q_b, ibc_q_t, ibc_s_b, &
                ibc_s_t,ibc_sa_t, ibc_uv_b, ibc_uv_t,                           &
-               intermediate_timestep_count, kappa,                             &
-               microphysics_morrison, microphysics_seifert,                    &
+               intermediate_timestep_count,                                    &
                nesting_offline, nudging,                                       &
                ocean, passive_scalar, rans_mode, rans_tke_e, tsc, use_cmax
@@ -220,4 +225,7 @@
 
     USE kinds
+
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert
 
     USE pegrid
@@ -597,5 +605,5 @@
        ENDIF
 
-       IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+       IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
 !             
 !--       Surface conditions cloud water (Dirichlet)
@@ -618,5 +626,5 @@
        ENDIF
 
-       IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
+       IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
 !             
 !--       Surface conditions rain water (Dirichlet)
@@ -736,9 +744,9 @@
        IF ( humidity )  THEN
           q_p(:,nys-1,:) = q_p(:,nys,:)
-          IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+          IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
              qc_p(:,nys-1,:) = qc_p(:,nys,:)
              nc_p(:,nys-1,:) = nc_p(:,nys,:)
           ENDIF
-          IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
+          IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
              qr_p(:,nys-1,:) = qr_p(:,nys,:)
              nr_p(:,nys-1,:) = nr_p(:,nys,:)
@@ -752,9 +760,9 @@
        IF ( humidity )  THEN
           q_p(:,nyn+1,:) = q_p(:,nyn,:)
-          IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+          IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
              qc_p(:,nyn+1,:) = qc_p(:,nyn,:)
              nc_p(:,nyn+1,:) = nc_p(:,nyn,:)
           ENDIF
-          IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
+          IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
              qr_p(:,nyn+1,:) = qr_p(:,nyn,:)
              nr_p(:,nyn+1,:) = nr_p(:,nyn,:)
@@ -768,9 +776,9 @@
        IF ( humidity )  THEN
           q_p(:,:,nxl-1) = q_p(:,:,nxl)
-          IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+          IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
              qc_p(:,:,nxl-1) = qc_p(:,:,nxl)
              nc_p(:,:,nxl-1) = nc_p(:,:,nxl)
           ENDIF
-          IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
+          IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
              qr_p(:,:,nxl-1) = qr_p(:,:,nxl)
              nr_p(:,:,nxl-1) = nr_p(:,:,nxl)
@@ -784,9 +792,9 @@
        IF ( humidity )  THEN
           q_p(:,:,nxr+1) = q_p(:,:,nxr)
-          IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+          IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
              qc_p(:,:,nxr+1) = qc_p(:,:,nxr)
              nc_p(:,:,nxr+1) = nc_p(:,:,nxr)
           ENDIF
-          IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
+          IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
              qr_p(:,:,nxr+1) = qr_p(:,:,nxr)
              nr_p(:,:,nxr+1) = nr_p(:,:,nxr)
Index: /palm/trunk/SOURCE/buoyancy.f90
===================================================================
--- /palm/trunk/SOURCE/buoyancy.f90	(revision 3273)
+++ /palm/trunk/SOURCE/buoyancy.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused Variable removed
 !
@@ -114,5 +117,7 @@
 !------------------------------------------------------------------------------!
  MODULE buoyancy_mod
- 
+
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  g
 
     PRIVATE
@@ -138,5 +143,5 @@
 
        USE control_parameters,                                                 &
-           ONLY:  atmos_ocean_sign, cos_alpha_surface, g, message_string,      &
+           ONLY:  atmos_ocean_sign, cos_alpha_surface, message_string,         &
                   pt_surface, sin_alpha_surface, sloping_surface
 
@@ -244,5 +249,5 @@
 
        USE control_parameters,                                                 &
-           ONLY:  atmos_ocean_sign, cos_alpha_surface, g, message_string,      &
+           ONLY:  atmos_ocean_sign, cos_alpha_surface, message_string,         &
                   pt_surface, sin_alpha_surface, sloping_surface
 
Index: /palm/trunk/SOURCE/calc_radiation.f90
===================================================================
--- /palm/trunk/SOURCE/calc_radiation.f90	(revision 3273)
+++ /palm/trunk/SOURCE/calc_radiation.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
 ! 
@@ -77,11 +80,25 @@
  MODULE calc_radiation_mod
  
+
+    USE arrays_3d,                                                             &
+        ONLY:  dzw, pt, ql, tend, d_exner, exner
+
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  c_p, lv_d_cp, sigma_sb
+
+    USE control_parameters,                                                    &
+        ONLY:  rho_surface
+
+    USE indices,                                                               &
+        ONLY:  nxl, nxr, nyn, nys, nzb, nzt, wall_flags_0
+
     USE kinds
-    
+
+    USE pegrid
+
     PRIVATE
     PUBLIC calc_radiation
-    
+
     LOGICAL, SAVE ::  first_call = .TRUE. !<
-    REAL(wp), SAVE ::  sigma = 5.67E-08_wp   !<
 
     REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE ::  lwp_ground         !<
@@ -103,21 +120,4 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE calc_radiation
-
-       USE arrays_3d,                                                          &
-           ONLY:  dzw, pt, ql, tend
-
-       USE cloud_parameters,                                                   &
-           ONLY:  cp, l_d_cp, pt_d_t, t_d_pt
-
-       USE control_parameters,                                                 &
-           ONLY:  rho_surface
-
-       USE indices,                                                            &
-           ONLY:  nxl, nxr, nyn, nys, nzb, nzt, wall_flags_0
-
-       USE kinds
-
-       USE pegrid
-
 
        IMPLICIT NONE
@@ -159,6 +159,6 @@
              lwp_top(nzt+1)  = rho_surface * ql(nzt+1,j,i) * dzw(nzt+1)
 
-             temperature     = pt(nzb,j,i) * t_d_pt(nzb) + l_d_cp * ql(nzb,j,i)
-             blackbody_emission(nzb) = sigma * temperature**4
+             temperature     = pt(nzb,j,i) * exner(nzb) + lv_d_cp * ql(nzb,j,i)
+             blackbody_emission(nzb) = sigma_sb * temperature**4
 
              DO  k = nzb+1, nzt
@@ -171,6 +171,6 @@
                                   rho_surface * ql(k_help,j,i) * dzw(k_help)
 
-                temperature     = pt(k,j,i) * t_d_pt(k) + l_d_cp * ql(k,j,i)
-                blackbody_emission(k) = sigma * temperature**4                 &
+                temperature     = pt(k,j,i) * exner(k) + lv_d_cp * ql(k,j,i)
+                blackbody_emission(k) = sigma_sb * temperature**4              &
                                       * MERGE( 1.0_wp, 0.0_wp,                 &
                                                BTEST( wall_flags_0(k,j,i), 0 ) )
@@ -182,7 +182,7 @@
              lwp_top(nzb)      = lwp_top(nzb+1)
 
-             temperature       = pt(nzt+1,j,i) * t_d_pt(nzt+1) + l_d_cp *      &
+             temperature       = pt(nzt+1,j,i) * exner(nzt+1) + lv_d_cp *      &
                                  ql(nzt+1,j,i)
-             blackbody_emission(nzt+1) = sigma * temperature**4
+             blackbody_emission(nzt+1) = sigma_sb * temperature**4
 
 !
@@ -232,5 +232,5 @@
 !--                Compute tendency term         
                    tend(k,j,i) = tend(k,j,i) -                                 &
-                                ( pt_d_t(k) / ( rho_surface * cp ) *           &
+                                ( d_exner(k) / ( rho_surface * c_p ) *         &
                                   ( df_p - df_m ) / dzw(k) )                   &
                                       * MERGE( 1.0_wp, 0.0_wp,                 &
@@ -253,21 +253,4 @@
     SUBROUTINE calc_radiation_ij( i, j )
 
-       USE arrays_3d,                                                          &
-           ONLY:  dzw, pt, ql, tend
-
-       USE cloud_parameters,                                                   &
-           ONLY:  cp, l_d_cp, pt_d_t, t_d_pt
-
-       USE control_parameters,                                                 &
-           ONLY:  rho_surface
-
-       USE indices,                                                            &
-           ONLY:  nzb, nzt, wall_flags_0
-
-       USE kinds
-
-       USE pegrid
-
-   
        IMPLICIT NONE
 
@@ -305,6 +288,6 @@
        lwp_top(nzt+1)  = rho_surface * ql(nzt+1,j,i) * dzw(nzt+1)
 
-       temperature     = pt(nzb,j,i) * t_d_pt(nzb) + l_d_cp * ql(nzb,j,i)
-       blackbody_emission(nzb) = sigma * temperature**4
+       temperature     = pt(nzb,j,i) * exner(nzb) + lv_d_cp * ql(nzb,j,i)
+       blackbody_emission(nzb) = sigma_sb * temperature**4
 
        DO  k = nzb+1, nzt
@@ -315,6 +298,6 @@
                             rho_surface * ql(k_help,j,i) * dzw(k_help)
 
-          temperature     = pt(k,j,i) * t_d_pt(k) + l_d_cp * ql(k,j,i)
-          blackbody_emission(k) = sigma * temperature**4                       &
+          temperature     = pt(k,j,i) * exner(k) + lv_d_cp * ql(k,j,i)
+          blackbody_emission(k) = sigma_sb * temperature**4                    &
                                       * MERGE( 1.0_wp, 0.0_wp,                 &
                                                BTEST( wall_flags_0(k,j,i), 0 ) )
@@ -325,7 +308,7 @@
        lwp_top(nzb)      = lwp_top(nzb+1)
 
-       temperature       = pt(nzt+1,j,i) * t_d_pt(nzt+1) + l_d_cp *            &
+       temperature       = pt(nzt+1,j,i) * exner(nzt+1) + lv_d_cp *            &
                            ql(nzt+1,j,i)
-       blackbody_emission(nzt+1) = sigma * temperature**4
+       blackbody_emission(nzt+1) = sigma_sb * temperature**4
 
 !
@@ -370,6 +353,6 @@
 !
 !--          Compute tendency term         
-             tend(k,j,i) = tend(k,j,i) - ( pt_d_t(k) / ( rho_surface * cp ) *  &
-                                         ( df_p - df_m ) / dzw(k) )            &
+             tend(k,j,i) = tend(k,j,i) - ( d_exner(k) / ( rho_surface * c_p )  &
+                                      *  ( df_p - df_m ) / dzw(k) )            &
                                       * MERGE( 1.0_wp, 0.0_wp,                 &
                                                BTEST( wall_flags_0(k,j,i), 0 ) )
